/*
 *    MCreator note:
 *
 *    If you lock base mod element files, you can edit this file and it won't get overwritten.
 *    If you change your modid or package, you need to apply these changes to this file MANUALLY.
 *
 *    Settings in @Mod annotation WON'T be changed in case of the base mod element
 *    files lock too, so you need to set them manually here in such case.
 *
 *    If you do not lock base mod element files in Workspace settings, this file
 *    will be REGENERATED on each build.
 *
 */
package net.mcreator.rpgmod;

import org.apache.logging.log4j.Logger;
import org.apache.logging.log4j.LogManager;

import net.minecraftforge.network.simple.SimpleChannel;
import net.minecraftforge.network.NetworkRegistry;
import net.minecraftforge.network.NetworkEvent;
import net.minecraftforge.fml.javafmlmod.FMLJavaModLoadingContext;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.eventbus.api.IEventBus;
import net.minecraftforge.event.TickEvent;
import net.minecraftforge.common.MinecraftForge;

import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.FriendlyByteBuf;

import net.mcreator.rpgmod.init.RpgModModSounds;
import net.mcreator.rpgmod.init.RpgModModPotions;
import net.mcreator.rpgmod.init.RpgModModParticleTypes;
import net.mcreator.rpgmod.init.RpgModModMobEffects;
import net.mcreator.rpgmod.init.RpgModModMenus;
import net.mcreator.rpgmod.init.RpgModModItems;
import net.mcreator.rpgmod.init.RpgModModFluids;
import net.mcreator.rpgmod.init.RpgModModFluidTypes;
import net.mcreator.rpgmod.init.RpgModModFeatures;
import net.mcreator.rpgmod.init.RpgModModEntities;
import net.mcreator.rpgmod.init.RpgModModBlocks;
import net.mcreator.rpgmod.init.RpgModModBlockEntities;
import net.mcreator.rpgmod.init.RpgModModBiomes;

import java.util.function.Supplier;
import java.util.function.Function;
import java.util.function.BiConsumer;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.List;
import java.util.Collection;
import java.util.ArrayList;
import java.util.AbstractMap;

@Mod("rpg_mod")
public class RpgModMod {
	public static final Logger LOGGER = LogManager.getLogger(RpgModMod.class);
	public static final String MODID = "rpg_mod";

	public RpgModMod() {
		MinecraftForge.EVENT_BUS.register(this);

		IEventBus bus = FMLJavaModLoadingContext.get().getModEventBus();
		RpgModModSounds.REGISTRY.register(bus);
		RpgModModBlocks.REGISTRY.register(bus);
		RpgModModItems.REGISTRY.register(bus);
		RpgModModEntities.REGISTRY.register(bus);
		RpgModModBlockEntities.REGISTRY.register(bus);
		RpgModModFeatures.REGISTRY.register(bus);
		RpgModModFluids.REGISTRY.register(bus);
		RpgModModFluidTypes.REGISTRY.register(bus);

		RpgModModMobEffects.REGISTRY.register(bus);
		RpgModModPotions.REGISTRY.register(bus);

		RpgModModParticleTypes.REGISTRY.register(bus);
		RpgModModMenus.REGISTRY.register(bus);
		RpgModModBiomes.REGISTRY.register(bus);
	}

	private static final String PROTOCOL_VERSION = "1";
	public static final SimpleChannel PACKET_HANDLER = NetworkRegistry.newSimpleChannel(new ResourceLocation(MODID, MODID), () -> PROTOCOL_VERSION, PROTOCOL_VERSION::equals, PROTOCOL_VERSION::equals);
	private static int messageID = 0;

	public static <T> void addNetworkMessage(Class<T> messageType, BiConsumer<T, FriendlyByteBuf> encoder, Function<FriendlyByteBuf, T> decoder, BiConsumer<T, Supplier<NetworkEvent.Context>> messageConsumer) {
		PACKET_HANDLER.registerMessage(messageID, messageType, encoder, decoder, messageConsumer);
		messageID++;
	}

	private static final Collection<AbstractMap.SimpleEntry<Runnable, Integer>> workQueue = new ConcurrentLinkedQueue<>();

	public static void queueServerWork(int tick, Runnable action) {
		workQueue.add(new AbstractMap.SimpleEntry(action, tick));
	}

	@SubscribeEvent
	public void tick(TickEvent.ServerTickEvent event) {
		if (event.phase == TickEvent.Phase.END) {
			List<AbstractMap.SimpleEntry<Runnable, Integer>> actions = new ArrayList<>();
			workQueue.forEach(work -> {
				work.setValue(work.getValue() - 1);
				if (work.getValue() == 0)
					actions.add(work);
			});
			actions.forEach(e -> e.getKey().run());
			workQueue.removeAll(actions);
		}
	}
}
