package net.mcreator.rpgmod.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.Checkbox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.Minecraft;

import net.mcreator.rpgmod.world.inventory.ClassselectorMenu;
import net.mcreator.rpgmod.network.ClassselectorButtonMessage;
import net.mcreator.rpgmod.RpgModMod;

import java.util.HashMap;

import com.mojang.blaze3d.vertex.PoseStack;
import com.mojang.blaze3d.systems.RenderSystem;

public class ClassselectorScreen extends AbstractContainerScreen<ClassselectorMenu> {
	private final static HashMap<String, Object> guistate = ClassselectorMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	Checkbox mage2;
	Checkbox Hunter2;
	Checkbox Warrior2;
	Checkbox Tree_monster_2;
	Checkbox Golem_2;
	Checkbox Zombie_2;
	Checkbox egg2;
	Button button_done;

	public ClassselectorScreen(ClassselectorMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 228;
		this.imageHeight = 165;
	}

	private static final ResourceLocation texture = new ResourceLocation("rpg_mod:textures/screens/classselector.png");

	@Override
	public void render(PoseStack ms, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(ms);
		super.render(ms, mouseX, mouseY, partialTicks);
		this.renderTooltip(ms, mouseX, mouseY);
	}

	@Override
	protected void renderBg(PoseStack ms, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		RenderSystem.setShaderTexture(0, texture);
		this.blit(ms, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
	}

	@Override
	protected void renderLabels(PoseStack poseStack, int mouseX, int mouseY) {
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_select_a_class"), 5, 6, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_tick_none_for_no_class"), 86, 6, -16777012);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_mage"), 5, 51, -13434829);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_hunter"), 5, 78, -16751104);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_warrior"), 5, 105, -3407872);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_press_done_then_press_e"), 59, 150, -12829636);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_evil_side"), 176, 24, -16777216);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_tree_monster"), 131, 51, -10079488);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_broken_golem"), 131, 105, -1);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_zombie"), 158, 78, -14275034);
		this.font.draw(poseStack, Component.translatable("gui.rpg_mod.classselector.label_good_side"), 14, 24, -15160094);
	}

	@Override
	public void onClose() {
		super.onClose();
		Minecraft.getInstance().keyboardHandler.setSendRepeatsToGui(false);
	}

	@Override
	public void init() {
		super.init();
		this.minecraft.keyboardHandler.setSendRepeatsToGui(true);
		button_done = new Button(this.leftPos + 86, this.topPos + 123, 45, 20, Component.translatable("gui.rpg_mod.classselector.button_done"), e -> {
			if (true) {
				RpgModMod.PACKET_HANDLER.sendToServer(new ClassselectorButtonMessage(0, x, y, z));
				ClassselectorButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		});
		guistate.put("button:button_done", button_done);
		this.addRenderableWidget(button_done);
		mage2 = new Checkbox(this.leftPos + 50, this.topPos + 42, 20, 20, Component.translatable("gui.rpg_mod.classselector.mage2"), false);
		guistate.put("checkbox:mage2", mage2);
		this.addRenderableWidget(mage2);
		Hunter2 = new Checkbox(this.leftPos + 50, this.topPos + 69, 20, 20, Component.translatable("gui.rpg_mod.classselector.Hunter2"), false);
		guistate.put("checkbox:Hunter2", Hunter2);
		this.addRenderableWidget(Hunter2);
		Warrior2 = new Checkbox(this.leftPos + 50, this.topPos + 96, 20, 20, Component.translatable("gui.rpg_mod.classselector.Warrior2"), false);
		guistate.put("checkbox:Warrior2", Warrior2);
		this.addRenderableWidget(Warrior2);
		Tree_monster_2 = new Checkbox(this.leftPos + 194, this.topPos + 42, 20, 20, Component.translatable("gui.rpg_mod.classselector.Tree_monster_2"), false);
		guistate.put("checkbox:Tree_monster_2", Tree_monster_2);
		this.addRenderableWidget(Tree_monster_2);
		Golem_2 = new Checkbox(this.leftPos + 194, this.topPos + 96, 20, 20, Component.translatable("gui.rpg_mod.classselector.Golem_2"), false);
		guistate.put("checkbox:Golem_2", Golem_2);
		this.addRenderableWidget(Golem_2);
		Zombie_2 = new Checkbox(this.leftPos + 194, this.topPos + 69, 20, 20, Component.translatable("gui.rpg_mod.classselector.Zombie_2"), false);
		guistate.put("checkbox:Zombie_2", Zombie_2);
		this.addRenderableWidget(Zombie_2);
		egg2 = new Checkbox(this.leftPos + 95, this.topPos + 69, 20, 20, Component.translatable("gui.rpg_mod.classselector.egg2"), false);
		guistate.put("checkbox:egg2", egg2);
		this.addRenderableWidget(egg2);
	}
}
