
package net.mcreator.rpgmod.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.rpgmod.init.RpgModModItems;
import net.mcreator.rpgmod.init.RpgModModFluids;
import net.mcreator.rpgmod.init.RpgModModFluidTypes;
import net.mcreator.rpgmod.init.RpgModModBlocks;

public abstract class SaninFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> RpgModModFluidTypes.SANIN_TYPE.get(), () -> RpgModModFluids.SANIN.get(), () -> RpgModModFluids.FLOWING_SANIN.get()).explosionResistance(1000f)
			.bucket(() -> RpgModModItems.SANIN_BUCKET.get()).block(() -> (LiquidBlock) RpgModModBlocks.SANIN.get());

	private SaninFluid() {
		super(PROPERTIES);
	}

	public static class Source extends SaninFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends SaninFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
